<cfcomponent displayname="FAQ Question List" extends="farcry.farcry_core.packages.rules.rules" hint="Lists the FAQ questions.">

	<cffunction access="public" name="execute" output="true">
		<cfargument name="objectID" required="Yes" type="uuid" default="">
		<cfargument name="dsn" required="false" type="string" default="#application.dsn#">

		<cfset var stObj = this.getData(arguments.objectid) /> 
		<cfset var html = "" />
		<cfset var lCategoryIDs = "" />
		<cfset var qFAQs = "" />
		<cfset var aRelatedIDs = "" />
		<cfset var stRelated = "" />
		<cfset var i = "" />
		<cfset var j = "" />
		<cfset var link = "" />

		<!--- find what category this is assigned to --->
		<cfset lCategoryIDs = application.factory.oCategory.getCategories(
				objectID = request.stObj.objectid,
				bReturnCategoryIDs = true) />

		<!--- get the FAQ questions that are assigned to this category also --->
		<cfset qFAQs = application.factory.oCategory.getData(
			lCategoryIDs = lCategoryIDs,
			typename = "bosFAQ",
			dsn = arguments.dsn) />

		<cfimport taglib="/farcry/farcry_core/tags/webskin" prefix="skin" />
		<cfimport taglib="/farcry/fourq/tags" prefix="q4" />

		<cfsavecontent variable="html">

		<cfif qFAQs.recordcount>
			<!--- output TOC --->
			<cfoutput><div id="FAQ-TOC"><ol></cfoutput>
			<cfloop from="1" to="#qFAQs.recordcount#" index="i">
				<cfoutput><li><a href="###i#">#qFAQs.question[i]#</a></li></cfoutput>
			</cfloop>			
			<cfoutput></ol></div></cfoutput>
			
			<!--- output the Questions --->
			<cfoutput><div id="FAQ-Qs"><dl></cfoutput>

			<cfloop from="1" to="#qFAQs.recordcount#" index="i">

				<!--- output the question --->
				<cfoutput><dt><a name="#i#"></a><span class="q-number">#i#. </span>#qFAQs.question[i]#</dt><dd></cfoutput>

				<!--- output the answer --->
				<cfoutput><p>#qFAQs.answer[i]#</p></cfoutput>

				<cfset stFAQ = createObject("component",application.types.bosFAQ.typepath).getData(qFAQs.objectid[i]) />

				<!--- output links to related content if there is any --->
				<cfif arrayLen(stFAQ.aRelatedIDs)>
					<cfset aRelatedIDs = stFAQ.aRelatedIDs />
					<cfoutput><ul></cfoutput>
					<cfloop from="1" to="#arrayLen(aRelatedIDs)#" index="j">
							<cfset stRelated = application.factory.oTree.contentObjectGet(objectid=aRelatedIDs[j]) />
							<cfoutput><li></cfoutput>
							<skin:buildLink objectid="#aRelatedIDs[j]#"><cfoutput>#stRelated.label#</cfoutput></skin:buildLink>
							<cfoutput></li></cfoutput>
					</cfloop>
					<cfoutput></ul></cfoutput>
				</cfif>
			
				<cfoutput></dd></cfoutput>
			</cfloop>
			<cfoutput></dl></div></cfoutput>
		</cfif>

		</cfsavecontent>

		<cfset arrayAppend(request.aInvocations,html) />

	</cffunction> 

</cfcomponent>
